"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
/** 
 * Code -> value
 * CodeBlock -> value
 * Header -> children
 * ListItem -> children
 * Link -> url, children
 * Image -> alt, url, title
*/
function _default(context) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var {
    Syntax,
    RuleError,
    report,
    getSource,
    locator
  } = context;
  return {
    [Syntax.ListItem](node) {
      var match = node.children.length === 0 ? true : false;
      if (match) {
        report(node, new context.RuleError("Empty ListItem", {
          padding: locator.range(node.range)
        }));
      }
    },
    [Syntax.Header](node) {
      var match = node.children.length === 0 ? true : false;
      if (match) {
        report(node, new context.RuleError("Empty Header", {
          padding: locator.range(node.range)
        }));
      }
    },
    [Syntax.Code](node) {
      var match = node.value.trim() === "" ? true : false;
      if (match) {
        report(node, new context.RuleError("Empty code block", {
          padding: locator.range(node.range)
        }));
      }
    },
    [Syntax.CodeBlock](node) {
      var match = node.value.trim() === "" ? true : false;
      if (match) {
        report(node, new context.RuleError("Empty code block", {
          padding: locator.range(node.range)
        }));
      }
    }
  };
}
//# sourceMappingURL=index.js.map